//+-----------------------------------------------------------------------------------+
//|  Copyright 2020, EA Builder Pro                                                   |
//|                                                                                   |
//|  https://www.eabuilderpro.com                                                     |
//|                                                                                   |
//|  A big thank you for using our platform! If you appreciate the                    |
//|  code we've generated for you, please help us by donating, so that                |
//|  we can continue to bring more features for you! This way you                     |
//|  can contribute what you can afford.                                              |
//|                                                                                   |
//|  Please trade responsibly. Using this EA can cause you to lose real money.        |
//|  Test throughly with a demo account and never leave an account without            |
//|  monitoring and supervision on a Live account.                                    |
//|                                                                                   |
//|  EA Builder Pro can not be held responsible for any losses, whatever the reason.  |
//|  Do not use this EA if you do not agree with these terms.                         |
//|                                                                                   |
//|  Thanks to all whom donated!                                                      |
//|                                                                                   |
//|  Special thanks to:                                                               |
//|  Ian W. (code)                                                                    |
//|  Rubén C. (feedback)                                                              |
//|                                                                                   |
//|  Copyright 2020, EA Builder Pro                                                   |
//+-----------------------------------------------------------------------------------+

//
//  Includes
//
#include <Trade\SymbolInfo.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\Trade.mqh>

//
//  Properties
//
#property copyright "Copyright 2020, EA Builder Pro"
#property link "https://www.eabuilderpro.com"
#property version "1.64"
#property strict

//
//  Globals
//
input int MagicNumber = 123456;
input double PipPointOverride = 0;
double PipPoint = 0.0001;
input bool OverrideIndicatorInputValues = 0;
uint OrderFillingType = -1;
bool StopEA = false;

//
//  MQL5 Init
//
// --- declaration of constants
#define OP_BUY 0           //Buy 
#define OP_SELL 1          //Sell
#define OP_BUYLIMIT 2      //BUY LIMIT pending order 
#define OP_SELLLIMIT 3     //SELL LIMIT pending order  
#define OP_BUYSTOP 4       //BUY STOP pending order  
#define OP_SELLSTOP 5      //SELL STOP pending order  
//---
#define OBJPROP_TIME1 300
#define OBJPROP_PRICE1 301
#define OBJPROP_TIME2 302
#define OBJPROP_PRICE2 303
#define OBJPROP_TIME3 304
#define OBJPROP_PRICE3 305
//---
#define OBJPROP_RAY 310
#define OBJPROP_FIBOLEVELS 200
//---
 
#define OBJPROP_FIRSTLEVEL1 211 
#define OBJPROP_FIRSTLEVEL2 212
#define OBJPROP_FIRSTLEVEL3 213
#define OBJPROP_FIRSTLEVEL4 214
#define OBJPROP_FIRSTLEVEL5 215
#define OBJPROP_FIRSTLEVEL6 216
#define OBJPROP_FIRSTLEVEL7 217
#define OBJPROP_FIRSTLEVEL8 218
#define OBJPROP_FIRSTLEVEL9 219
#define OBJPROP_FIRSTLEVEL10 220
#define OBJPROP_FIRSTLEVEL11 221
#define OBJPROP_FIRSTLEVEL12 222
#define OBJPROP_FIRSTLEVEL13 223
#define OBJPROP_FIRSTLEVEL14 224
#define OBJPROP_FIRSTLEVEL15 225
#define OBJPROP_FIRSTLEVEL16 226
#define OBJPROP_FIRSTLEVEL17 227
#define OBJPROP_FIRSTLEVEL18 228
#define OBJPROP_FIRSTLEVEL19 229
#define OBJPROP_FIRSTLEVEL20 230
#define OBJPROP_FIRSTLEVEL21 231
#define OBJPROP_FIRSTLEVEL22 232
#define OBJPROP_FIRSTLEVEL23 233
#define OBJPROP_FIRSTLEVEL24 234
#define OBJPROP_FIRSTLEVEL25 235
#define OBJPROP_FIRSTLEVEL26 236
#define OBJPROP_FIRSTLEVEL27 237
#define OBJPROP_FIRSTLEVEL28 238
#define OBJPROP_FIRSTLEVEL29 239
#define OBJPROP_FIRSTLEVEL30 240
#define OBJPROP_FIRSTLEVEL31 241
//---
#define MODE_OPEN 0
#define MODE_CLOSE 3
#define MODE_VOLUME 4 
#define MODE_REAL_VOLUME 5
#define MODE_TRADES 0
#define MODE_HISTORY 1
#define SELECT_BY_POS 0
#define SELECT_BY_TICKET 1
//---
#define DOUBLE_VALUE 0
#define FLOAT_VALUE 1
#define LONG_VALUE INT_VALUE
//---
#define CHART_BAR 0
#define CHART_CANDLE 1
//---
#define MODE_ASCEND 0
#define MODE_DESCEND 1
//---
#define MODE_LOW 1
#define MODE_HIGH 2
#define MODE_TIME 5
#define MODE_BID 9
#define MODE_ASK 10
#define MODE_POINT 11
#define MODE_DIGITS 12
#define MODE_SPREAD 13
#define MODE_STOPLEVEL 14
#define MODE_LOTSIZE 15
#define MODE_TICKVALUE 16
#define MODE_TICKSIZE 17
#define MODE_SWAPLONG 18
#define MODE_SWAPSHORT 19
#define MODE_STARTING 20
#define MODE_EXPIRATION 21
#define MODE_TRADEALLOWED 22
#define MODE_MINLOT 23
#define MODE_LOTSTEP 24
#define MODE_MAXLOT 25
#define MODE_SWAPTYPE 26
#define MODE_PROFITCALCMODE 27
#define MODE_MARGINCALCMODE 28
#define MODE_MARGININIT 29
#define MODE_MARGINMAINTENANCE 30
#define MODE_MARGINHEDGED 31
#define MODE_MARGINREQUIRED 32
#define MODE_FREEZELEVEL 33
//---
#define EMPTY -1
//---
#define CharToStr CharToString
#define DoubleToStr DoubleToString
#define StrToDouble StringToDouble
#define StrToInteger (int)StringToInteger
#define StrToTime StringToTime
#define TimeToStr TimeToString 
#define StringGetChar StringGetCharacter
#define StringSetChar StringSetCharacter
#define UnitsOneLot 100000

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_TIMEFRAMES TimeframeConvert(int tf)
  {
   switch(tf)
     {
      case 0: return(PERIOD_CURRENT);
      case 1: return(PERIOD_M1);
      case 5: return(PERIOD_M5);
      case 15: return(PERIOD_M15);
      case 30: return(PERIOD_M30);
      case 60: return(PERIOD_H1);
      case 240: return(PERIOD_H4);
      case 1440: return(PERIOD_D1);
      case 10080: return(PERIOD_W1);
      case 43200: return(PERIOD_MN1);
      
      case 2: return(PERIOD_M2);
      case 3: return(PERIOD_M3);
      case 4: return(PERIOD_M4);      
      case 6: return(PERIOD_M6);
      case 10: return(PERIOD_M10);
      case 12: return(PERIOD_M12);
      case 16385: return(PERIOD_H1);
      case 16386: return(PERIOD_H2);
      case 16387: return(PERIOD_H3);
      case 16388: return(PERIOD_H4);
      case 16390: return(PERIOD_H6);
      case 16392: return(PERIOD_H8);
      case 16396: return(PERIOD_H12);
      case 16408: return(PERIOD_D1);
      case 32769: return(PERIOD_W1);
      case 49153: return(PERIOD_MN1);      
      default: return(PERIOD_CURRENT);
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_MA_METHOD MethodConvert(int method)
  {
   switch(method)
     {
      case 0: return(MODE_SMA);
      case 1: return(MODE_EMA);
      case 2: return(MODE_SMMA);
      case 3: return(MODE_LWMA);
      default: return(MODE_SMA);
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_APPLIED_PRICE PriceConvert(int price)
  {
   switch(price)
     {
      case 1: return(PRICE_CLOSE);
      case 2: return(PRICE_OPEN);
      case 3: return(PRICE_HIGH);
      case 4: return(PRICE_LOW);
      case 5: return(PRICE_MEDIAN);
      case 6: return(PRICE_TYPICAL);
      case 7: return(PRICE_WEIGHTED);
      default: return(PRICE_CLOSE);
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_STO_PRICE StoFieldConvert(int field)
  {
   switch(field)
     {
      case 0: return(STO_LOWHIGH);
      case 1: return(STO_CLOSECLOSE);
      default: return(STO_LOWHIGH);
     }
  }

//+------------------------------------------------------------------+
enum ALLIGATOR_MODE  { agMODE_GATORJAW=1, agMODE_GATORTEETH, agMODE_GATORLIPS };
enum ADX_MODE        { adxMODE_MAIN, adxMODE_PLUSDI, adxMODE_MINUSDI };
enum UP_LOW_MODE     { ulMODE_BASE, ulMODE_UPPER, ulMODE_LOWER };
enum ICHIMOKU_MODE   { imMODE_TENKANSEN=1, imMODE_KIJUNSEN, imMODE_SENKOUSPANA, imMODE_SENKOUSPANB, imMODE_CHINKOUSPAN };
enum MAIN_SIGNAL_MODE{ msMODE_MAIN, msMODE_SIGNAL };
enum ORDER_GROUP_TYPE { Single=1, SymbolOrderType=2, SymbolCode=3, Basket=4 };
enum ORDER_PROFIT_CALCULATION_TYPE { Pips=1, Money=2 };

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CopyBufferOneValue(int handle,int index,int shift)
{
   double buf[];

   if(CopyBuffer(handle,index,shift,1,buf)>0)
      return(buf[0]);

   return(EMPTY_VALUE);
}

//
//  MQL5 Library Functions
//
double Ask_LibFunc()
{
   MqlTick last_tick;
   SymbolInfoTick(_Symbol,last_tick);
   return last_tick.ask;
}

double Bid_LibFunc()
{
   MqlTick last_tick;
   SymbolInfoTick(_Symbol,last_tick);
   return last_tick.bid;
}

void Open_LibFunc(double& open[], int count)
{
   ArraySetAsSeries(open,true);
   CopyOpen(_Symbol,_Period,0,count,open);
}

void Close_LibFunc(double& close[], int count)
{
   ArraySetAsSeries(close,true);
   CopyClose(_Symbol,_Period,0,count,close);
}

void Low_LibFunc(double& low[], int count)
{
   ArraySetAsSeries(low,true);
   CopyLow(_Symbol,_Period,0,count,low);
}

void High_LibFunc(double& high[], int count)
{
   ArraySetAsSeries(high,true);
   CopyHigh(_Symbol,_Period,0,count,high);
}

double AccountBalance_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_BALANCE);
}

double AccountCredit_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_CREDIT);
}

double AccountEquity_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_EQUITY);
}

double AccountFreeMargin_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_MARGIN_FREE);
}

double AccountMargin_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_MARGIN);
}

double AccountProfit_LibFunc()
{
   return AccountInfoDouble(ACCOUNT_PROFIT);
}

string AccountCompany_LibFunc()
{
   return AccountInfoString(ACCOUNT_COMPANY);
}

string AccountCurrency_LibFunc()
{
   return AccountInfoString(ACCOUNT_CURRENCY);
}

string AccountName_LibFunc()
{
   return AccountInfoString(ACCOUNT_NAME);
}

string AccountServer_LibFunc()
{
   return AccountInfoString(ACCOUNT_SERVER);
}

long AccountLeverage_LibFunc()
{
   return AccountInfoInteger(ACCOUNT_LEVERAGE);
}

long AccountNumber_LibFunc()
{
   return AccountInfoInteger(ACCOUNT_LOGIN);
}

double MarketInfo_LibFunc(string symbol, int type)
{
   switch(type)
     {
      case MODE_LOW:
         return(SymbolInfoDouble(symbol,SYMBOL_LASTLOW));
      case MODE_HIGH:
         return(SymbolInfoDouble(symbol,SYMBOL_LASTHIGH));
      case MODE_TIME:
         return((double)SymbolInfoInteger(symbol,SYMBOL_TIME));
      case MODE_BID:
         return(Bid_LibFunc());
      case MODE_ASK:
         return(Ask_LibFunc());
      case MODE_POINT:
         return(SymbolInfoDouble(symbol,SYMBOL_POINT));
      case MODE_DIGITS:
         return((double)SymbolInfoInteger(symbol,SYMBOL_DIGITS));
      case MODE_SPREAD:
         return((double)SymbolInfoInteger(symbol,SYMBOL_SPREAD));
      case MODE_STOPLEVEL:
         return((double)SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL));
      case MODE_LOTSIZE:
         return(SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE));
      case MODE_TICKVALUE:
         return(SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE));
      case MODE_TICKSIZE:
         return(SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE));
      case MODE_SWAPLONG:
         return(SymbolInfoDouble(symbol,SYMBOL_SWAP_LONG));
      case MODE_SWAPSHORT:
         return(SymbolInfoDouble(symbol,SYMBOL_SWAP_SHORT));
      case MODE_STARTING:
         return(0);
      case MODE_EXPIRATION:
         return(0);
      case MODE_TRADEALLOWED:
         return(0);
      case MODE_MINLOT:
         return(SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN));
      case MODE_LOTSTEP:
         return(SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP));
      case MODE_MAXLOT:
         return(SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX));
      case MODE_SWAPTYPE:
         return((double)SymbolInfoInteger(symbol,SYMBOL_SWAP_MODE));
      case MODE_PROFITCALCMODE:
         return((double)SymbolInfoInteger(symbol,SYMBOL_TRADE_CALC_MODE));
      case MODE_MARGINCALCMODE:
         return(0);
      case MODE_MARGININIT:
         return(0);
      case MODE_MARGINMAINTENANCE:
         return(0);
      case MODE_MARGINHEDGED:
         return(0);
      case MODE_MARGINREQUIRED:
         return(0);
      case MODE_FREEZELEVEL:
         return((double)SymbolInfoInteger(symbol,SYMBOL_TRADE_FREEZE_LEVEL));
   
      default: return(0);
     }
   return(0);
}


uint GetFillingType()
{
   uint fillingType = -1;

   uint filling=(uint)SymbolInfoInteger(Symbol(),SYMBOL_FILLING_MODE);
   if((filling&SYMBOL_FILLING_FOK)==SYMBOL_FILLING_FOK)
   {
      fillingType=ORDER_FILLING_FOK;
      Print("Setting filling type FOK");
      
   }
   else if((filling&SYMBOL_FILLING_IOC)==SYMBOL_FILLING_IOC)
   {
      fillingType=ORDER_FILLING_IOC;
      Print("Setting filling type IOC");
   }
   
   return fillingType;
}

void SetPipPoint()
{
   if (PipPointOverride != 0)
   {
      PipPoint = PipPointOverride;
   } else
   {
      PipPoint = GetRealPipPoint(Symbol());
   }
   
   Print("Point: " + DoubleToStr(PipPoint, 5));
}

// Pip Point Function
double GetRealPipPoint(string Currency)
{
	double calcPoint = 0;
	double calcDigits = Digits();
	Print("Digits: " + DoubleToString(calcDigits));
 
	if(calcDigits == 2 || calcDigits == 3) 
		calcPoint = 0.01;
	else if(calcDigits == 4 || calcDigits == 5) 
		calcPoint = 0.0001;

	return(calcPoint);
}
//
//  Indicator Inputs
//
//
//  Indicators
//
//
//  Order
//
class Order
{
	public:
		ulong Ticket;
		ENUM_ORDER_TYPE Type;
		ENUM_ORDER_STATE State;
		long MagicNumber;
		double Lots;
		datetime OpenTime;
		double OpenPrice;
		datetime CloseTime;
		double ClosePrice;
		double StopLoss;
		double TakeProfit;
		datetime Expiration;
		double CurrentProfitPips;
		double HighestProfitPips;
		double LowestProfitPips;
		string Comment;
		uint TradeRetCode;
		ulong TradeDealTicket;
		double TradePrice;
		double TradeVolume;
		double Commission;
		string SymbolCode;

		void Order()
		{
		}

		void Order(Order* order)
		{
			Ticket = order.Ticket;
			Type = order.Type;
			State = order.State;
			MagicNumber = order.MagicNumber;
			Lots = order.Lots;
			OpenTime = order.OpenTime;
			OpenPrice = order.OpenPrice;
			CloseTime = order.CloseTime;
			ClosePrice = order.ClosePrice;
			StopLoss = order.StopLoss;
			TakeProfit = order.TakeProfit;
			Expiration = order.Expiration;
			CurrentProfitPips = order.CurrentProfitPips;
			HighestProfitPips = order.HighestProfitPips;
			LowestProfitPips = order.LowestProfitPips;
			Comment = order.Comment;
			TradeRetCode = order.TradeRetCode;
			TradeDealTicket = order.TradeDealTicket;
			TradePrice = order.TradePrice;
			TradeVolume = order.TradeVolume;
			Commission = order.Commission;
			SymbolCode = order.SymbolCode;
		}

		double CalculateProfitPipettes()
		{
		    switch (Type) 
		    {
				case ORDER_TYPE_BUY:
				{
		            double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID); 		
				    return (Bid - OpenPrice);
				    break;
				}

				case ORDER_TYPE_SELL:
				{
		            double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK); 		
				    return (OpenPrice - Ask);
				    break;
				}
		    }

		    return 0;
		}

		double CalculateProfitPips()
		{
		    double pipettes = CalculateProfitPipettes();
		    double pips = pipettes / PipPoint;
		    return pips;
		}

		double CalculateProfitCurrency()
		{
		    switch (Type) 
			{
		        case OP_BUY:
		            return (SymbolInfoDouble(_Symbol, SYMBOL_BID) - OpenPrice) * (UnitsOneLot * TradeVolume) - Commission;
		            break;
		        case OP_SELL:
		            return (OpenPrice - SymbolInfoDouble(_Symbol, SYMBOL_ASK)) * (UnitsOneLot * TradeVolume) - Commission;
		            break;
			}
		    return 0;
		}

		void ~Order()
		{
		}
};

//
//  OrderCollection
//
class OrderCollection
{
    private:
        Order* _orders[];
        int _pointer;
        int _size;

    public:
        void OrderCollection()
        {
            _pointer = -1;
            _size = 0;
        }

        void ~OrderCollection()
        {
            for (int i = 0; i < ArraySize(_orders); i++)
            {
                delete(_orders[i]);
            }
        }

        void Add(Order* item)
        {
            _size = _size + 1;
            ArrayResize(_orders, _size, 8);

            _orders[(_size - 1)] = item;
        }

        Order* Remove(int index)
        {
            Order* removed = NULL;

            if (index >= 0 && index < _size)
            {
               removed = _orders[index];
               
               for (int i = index; i < (_size - 1); i++)
               {
                   _orders[i] = _orders[i + 1];
               }
   
               ArrayResize(_orders, ArraySize(_orders) - 1, 8);
               _size = _size - 1;
            }
            
            return removed;
        }

        Order* Get(int index)
        {
            if (index >= 0 && index < _size)
            {
                return _orders[index];
            }

            return NULL;
        }

        int Count()
        {
            return _size;
        }

        void Rewind()
        {
            _pointer = -1;
        }

        Order* Next()
        {
            _pointer++;
            if (_pointer == _size)
            {
                Rewind();
                return NULL;
            }

            return Current();
        }

        Order* Prev()
        {
            _pointer--;
            if (_pointer == -1)
            {
                return NULL;
            }

            return Current();
        }

        bool HasNext()
        {
            return (_pointer < (_size - 1));
        }

        Order* Current()
        {
            return _orders[_pointer];
        }

        int Key()
        {
            return _pointer;
        }
        
		int GetKeyByTicket(ulong ticket)
		{
		    int keyFound = -1;
		    for (int i = 0; i < ArraySize(_orders); i++)
		    {
		        if (_orders[i].Ticket == ticket)
		        {
		            keyFound = i;
		        }
		    }
		    return keyFound;
		}

		int CountByOrderType(ENUM_ORDER_TYPE orderType)
		{
		    int counter = 0;
		    for (int i = 0; i < ArraySize(_orders); i++)
		    {
		        if (_orders[i].Type == orderType)
		        {
		            counter++;
		        }
		    }
		    return counter;   
		}

};

//
//  OrderRepository
//
class OrderRepository
{
   private:
      static Order* getByTicket(ulong ticket)
      {
         bool orderSelected = OrderSelect(ticket);
         if (orderSelected) 
         {
            Order* order = new Order();
            OrderRepository::fetchSelected(order);
            return order;
         } 
         else 
         {
            return NULL;
         }
      }

      static datetime OrderCloseTimeMQL4(ulong ticket)
      {
         return (datetime)(HistoryOrderGetInteger(ticket, ORDER_TIME_DONE_MSC) / 1000);
      }
      
      static double OrderClosePriceMQL4(ulong ticket)
      {
         return HistoryOrderGetDouble(ticket, ORDER_PRICE_CURRENT);
      }
   
      static void fetchSelected(Order& order)
      {
         COrderInfo orderInfo;
         
         order.Ticket = orderInfo.Ticket(); // OrderTicket();
         order.Type = orderInfo.OrderType(); // OrderType();
         order.State = orderInfo.State(); // NEW for MQL5
         order.MagicNumber = orderInfo.Magic(); // OrderMagicNumber();
         order.Lots = orderInfo.VolumeInitial(); // OrderLots();
         order.OpenPrice = orderInfo.PriceOpen(); // OrderOpenPrice();
         order.StopLoss = orderInfo.StopLoss(); // OrderStopLoss();
         order.TakeProfit = orderInfo.TakeProfit(); // OrderTakeProfit();
         order.Expiration = orderInfo.TimeExpiration(); // OrderExpiration();
         order.Comment = orderInfo.Comment(); // OrderComment();
         order.OpenTime = orderInfo.TimeSetup(); // OrderOpenTime();
         order.CloseTime = OrderCloseTimeMQL4(order.Ticket); // MQL5: orderInfo.TimeDone(); // MQL4: OrderCloseTime();
         order.SymbolCode = orderInfo.Symbol();
      }
      
      static bool modify(ulong ticket, double stopLoss = NULL, double takeProfit = NULL)
      {
         // ref to trade functions
         CTrade trade;
         
         
         // select the order
         Order* order = OrderRepository::getByTicket(ticket);
        
         double price = order.OpenPrice;
         stopLoss = (stopLoss == NULL)? order.StopLoss: stopLoss;
         takeProfit = (takeProfit == NULL)? order.TakeProfit: takeProfit;
         datetime expiration = order.Expiration;
         
         // check state, and moify according to current state
         bool result = false;
         if (order.State == ORDER_STATE_PLACED)
            result = trade.OrderModify(ticket, price, stopLoss, takeProfit, ORDER_TIME_SPECIFIED, expiration, 0);
         else if (order.State == ORDER_STATE_FILLED)
            result = trade.PositionModify(ticket, stopLoss, takeProfit);
         
        if (CheckPointer(order) == POINTER_DYNAMIC)
            delete(order);

         return result;
      }
      
   public:
      static OrderCollection* GetOpenOrders(int magic = NULL, int type = NULL)
      {
         // In MQL5: Orders are pending orders, as soon as they are executed
         // they become (part of) a position. The OrdersTotal() function in MQL5
         // thus only retrieves pendings, we want both pending as well as open orders
         // part of the position
         OrderCollection* orders = new OrderCollection();
         
         // Pending orders
         for (int orderIndex = 0; orderIndex < OrdersTotal(); orderIndex++) 
         {
            // NOTE: First get the ticket of the order in the list, specified by index.
            // THEN: Locate the order by ticket
            bool orderSelected = OrderSelect(OrderGetTicket(orderIndex));
            
            if (orderSelected) 
            {
               Order* order = new Order();
               OrderRepository::fetchSelected(order);
               
               if (true
                  && (magic == NULL || magic == order.MagicNumber)
                  && (type == NULL || type == order.Type)) 
               {
                  orders.Add(order);
               } 
               else 
               {
                  if (CheckPointer(order) == POINTER_DYNAMIC)
                      delete(order);
               }
            }
         }   
         
         // Open orders by positions (netting system)
         int total = PositionsTotal();                                        // .GET  number of open positions
         for (int i = total - 1; i >= 0; i--)                                 // .ITER  over all open positions
         {                                                                    // .GET  params of the order:
            ulong  position_ticket = PositionGetTicket(i);                    //  - ticket of the position
            string position_symbol = PositionGetString(POSITION_SYMBOL);      //  - symbol 
            ulong  position_magicNumber = PositionGetInteger(POSITION_MAGIC);     //  - MagicNumber of the position
            double volume           = PositionGetDouble(POSITION_VOLUME);     //  - volume of the position
            double open_price       = PositionGetDouble(POSITION_PRICE_OPEN);
            datetime open_time       = (datetime)PositionGetInteger(POSITION_TIME);
            ENUM_POSITION_TYPE positionType = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);   //  - type of the position
            if (position_magicNumber == MagicNumber)                                         // .IF MATCH:
            {
               Order* order = new Order();
               order.Ticket = position_ticket; // Maybe a position ticket is different from order ticket? evaluation: ?
               if (positionType == POSITION_TYPE_BUY)
               {
                  order.Type = ORDER_TYPE_BUY;
               } else if (positionType == POSITION_TYPE_SELL)
               {
                  order.Type = ORDER_TYPE_SELL;
               }
               order.Lots = volume;
               order.OpenPrice = open_price;
               order.OpenTime = open_time;
               order.MagicNumber = MagicNumber;
               order.SymbolCode = Symbol();
               
               if (true
                  && (magic == NULL || magic == order.MagicNumber)
                  && (type == NULL || type == order.Type)) 
               {
                  orders.Add(order);
               } 
               else 
               {
                  if (CheckPointer(order) == POINTER_DYNAMIC)
                      delete(order);
               }
            }
         }   
         
         return orders;
      }
   
      static ulong ExecuteOpenBuy(Order* order)
      {
         ulong ticket = -1;

         MqlTradeRequest request = {0};
         MqlTradeResult result = {0};
         
         request.action   = TRADE_ACTION_DEAL;                     // type of trade operation
         request.symbol   = Symbol();                              // symbol
         request.volume   = order.Lots;							   // volume lot
         request.type     = ORDER_TYPE_BUY;                        // order type
         request.price    = Ask_LibFunc();                             // price for opening
         request.deviation= 10;                                     // allowed deviation from the price
         request.magic    = MagicNumber;                           // MagicNumber of the order
         // request.sl       = order.StopLoss;
         // request.tp       = order.TakeProfit;
         // request.comment  = order.Comment;
         request.type_filling = (ENUM_ORDER_TYPE_FILLING)OrderFillingType;
         
         //--- send the request
         if(OrderSend(request, result) == true)
         {
            //--- information about the operation
            // PrintFormat("OrderSend: retcode=%u  deal=%I64u  order=%I64u",result.retcode,result.deal,result.order);
   
            if (result.retcode == TRADE_RETCODE_DONE || result.retcode == TRADE_RETCODE_PLACED)
            {
               ticket = result.order;
               
               // get information about the order/deal
               order.Ticket = result.order;
               order.OpenPrice = result.price;
               order.OpenTime = TimeCurrent();
               
               // save all relevant returned data
               order.TradeRetCode = result.retcode;
               order.TradeDealTicket = result.deal;
               order.TradePrice = result.price;
               order.TradeVolume = result.volume;
            }
         }
         else
         {
            PrintFormat("OrderSend: error %d", GetLastError());     // if unable to send the request, output the error code
			if (result.retcode == TRADE_RETCODE_NO_MONEY)
            {
               StopEA = true;
            }
         }
         
         return ticket;
      }
   
      static ulong ExecuteOpenSell(Order* order)
      {
         ulong ticket = -1;

         MqlTradeRequest request = {0};
         MqlTradeResult result = {0};
         
         request.action   = TRADE_ACTION_DEAL;                     // type of trade operation
         request.symbol   = Symbol();                              // symbol
         request.volume   = order.Lots;							   // volume lot
         request.type     = ORDER_TYPE_SELL;                       // order type
         request.price    = Bid_LibFunc();                             // price for opening
         request.deviation= 10;                                     // allowed deviation from the price
         request.magic    = MagicNumber;                           // MagicNumber of the order
         // request.sl       = order.StopLoss;
         // request.tp       = order.TakeProfit;
         // request.comment  = order.Comment;
         request.type_filling = (ENUM_ORDER_TYPE_FILLING)OrderFillingType;
        
         //--- send the request
         if(OrderSend(request, result))
         {
            //--- information about the operation
            // PrintFormat("OrderSend: retcode=%u  deal=%I64u  order=%I64u",result.retcode,result.deal,result.order);
   
            if (result.retcode == TRADE_RETCODE_DONE || result.retcode == TRADE_RETCODE_PLACED)
            {
               ticket = result.order;
               
               // get information about the order/deal
               order.Ticket = result.order;
               order.OpenPrice = result.price;
               order.OpenTime = TimeCurrent();
               
               // save all relevant returned data
               order.TradeRetCode = result.retcode;
               order.TradeDealTicket = result.deal;
               order.TradePrice = result.price;
               order.TradeVolume = result.volume;
            }
         }
         else
		 {
            PrintFormat("OrderSend: error %d", GetLastError());     // if unable to send the request, output the error code
			if (result.retcode == TRADE_RETCODE_NO_MONEY)
            {
               StopEA = true;
            }
		 }
         
         return ticket;
      }
      
      static bool ClosePosition(Order* order)
      {
         CPositionInfo  m_position;                   // trade position object
         CTrade         m_trade;                      // trading object
      
         for(int i=PositionsTotal()-1;i>=0;i--) // returns the number of current positions
            if(m_position.SelectByIndex(i))     // selects the position by index for further access to its properties
               if(m_position.Ticket() == order.Ticket && m_position.Symbol() == order.SymbolCode && m_position.Magic() == MagicNumber)
               {
                  m_trade.PositionClose(m_position.Ticket()); // close a position by the specified symbol
                  // Print("ClosePosition: " + name);
                  return true;
               }
                  
         return false;
      }

	  static Order* GetLastClosedOrder()
      {
           Order* order = NULL;
           
           if (HistorySelect(0,TimeCurrent()))
           {
             for (int i=HistoryDealsTotal()-1; i>=0; i--)
             {
               ulong ticket=HistoryDealGetTicket(i);
               if (HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_OUT)
               {
                    order = new Order();
                    order.OpenTime = 0; // A close deal only contains a close time setting this value explicit so that processing is more clear
                    order.CloseTime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
                    
                    // if the last close deal was buy, then the order was a sell and the other way around
                    long dealType = HistoryDealGetInteger(ticket,DEAL_TYPE);
                    if (dealType == ORDER_TYPE_BUY)
                    {
                        order.Type = ORDER_TYPE_SELL;
                    }
                    else if (dealType == ORDER_TYPE_SELL)
                    {
                        order.Type = ORDER_TYPE_BUY;
                    }
                    else
                    {
                     Alert("Unkown order.Type in GetLastClosedOrder");
                    }
                    
                    break;
               }
             }
           }
           return order;
      }
      
      static bool CloseOrder(Order* order)
      {
         // MQL5: CloseOrder does not exists. 
         // If the number of open orders on the symbol is bigger than one, 
         // and we want to close a specific order, we need to 
         // counter it with an opposite OrderSend
         // If the number op open orders on the symbol is one, we can close
         // the position entirely
         
         // Lets assume this function is called when there is more than one open order
         
         double price = NULL;
         switch (order.Type) 
         {
            case ORDER_TYPE_BUY:
               price = Bid_LibFunc();
               break;
            case ORDER_TYPE_SELL:
               price = Ask_LibFunc();
               break;
         }
         
         if (price != NULL) 
         {
            ulong ticket = -1;
   
            MqlTradeRequest request = {0};
            MqlTradeResult result = {0};
            
            request.action   = TRADE_ACTION_DEAL;                     // type of trade operation
            request.symbol   = Symbol();                              // symbol
            request.volume   = order.Lots;
            if (order.Type == ORDER_TYPE_SELL)
            {
               // request.type = ORDER_TYPE_BUY;                        // order type
               request.type = ORDER_TYPE_CLOSE_BY;                        // order type
               request.price    = Ask_LibFunc();                             // price for opening
            }
            else
            {
               // request.type = ORDER_TYPE_SELL;
               request.type = ORDER_TYPE_CLOSE_BY;
               request.price    = Bid_LibFunc();                             // price for opening
            }
            request.deviation= 10;                                     // allowed deviation from the price
            request.magic    = MagicNumber;                           // MagicNumber of the order
            // request.sl       = order.StopLoss;
            // request.tp       = order.TakeProfit;
            // request.comment  = order.Comment;
            request.type_filling = (ENUM_ORDER_TYPE_FILLING)OrderFillingType;
            
            //--- send the request
            if(OrderSend(request, result) == true)
            {
               //--- information about the operation
               // PrintFormat("OrderSend: retcode=%u  deal=%I64u  order=%I64u",result.retcode,result.deal,result.order);
      
               if (result.retcode == TRADE_RETCODE_DONE || result.retcode == TRADE_RETCODE_PLACED)
               {
                  ticket = result.order;
                  
                  // get information about the order/deal
                  order.ClosePrice = result.price;
                  order.CloseTime = TimeCurrent();
               }
            }
            else
               PrintFormat("OrderSend: error %d", GetLastError());     // if unable to send the request, output the error code
            
            return ticket != -1;
         }
         return false;
      }
   
      static bool OpenOrder(Order* order)
      {
         double price = NULL;
         ulong ticketId = -1;
         switch (order.Type) 
         {
            case ORDER_TYPE_BUY:
               ticketId = ExecuteOpenBuy(order);
               break;
            case ORDER_TYPE_SELL:
               ticketId = ExecuteOpenSell(order);
               break;
         }
         
         return ticketId != -1;
      }
};

//
//  OrderGroupData
//
class OrderGroupData
{
	public:
		OrderCollection* OrderGroup;

		void OrderGroupData()
		{
			OrderGroup = new OrderCollection();
		}

		void OrderGroupData(OrderGroupData* ordergroupdata)
		{
			OrderGroup = ordergroupdata.OrderGroup;
		}

		void ~OrderGroupData()
		{
			if (OrderGroup != NULL && CheckPointer(OrderGroup) == POINTER_DYNAMIC)
				delete(OrderGroup);
		}
};

//
//  OrderGroupHashMap
//
class OrderGroupHashEntry 
{
    public:
        string _key;
        OrderGroupData* _val;
        OrderGroupHashEntry *_next;

        OrderGroupHashEntry() 
        {
            _key=NULL;
            _val=NULL;
            _next=NULL;
        }

        OrderGroupHashEntry(string key, OrderGroupData *val) 
        {
            _key=key;
            _val=val;
            _next=NULL;
        }

        ~OrderGroupHashEntry() 
        {
        }
};

class OrderGroupHashMap 
{
    private:
        uint _hashSlots; 
        int _resizeThreshold;
        int _hashEntryCount;
        OrderGroupHashEntry* _buckets[];
   
        bool _adoptValues;
   
        void init(uint size, bool adoptValues)
        {
            _hashSlots = 0;
            _hashEntryCount = 0;
            _adoptValues = adoptValues;
   
            rehash(size);
        }

        uint hash(string s)
        {
            uchar c[];
            uint h = 0;
   
            if (s != NULL) 
            {
                h = 5381;
                int n = StringToCharArray(s,c);
                for(int i = 0 ; i < n ; i++) 
                {
                    h = ((h << 5 ) + h ) + c[i];
                }
            }
           
            return h % _hashSlots;
        }

        uint _foundIndex;
        OrderGroupHashEntry* _foundEntry;
        OrderGroupHashEntry* _foundPrev;
                             
        bool find(string keyName) 
        {
            bool found = false;
           
            _foundPrev = NULL;
            _foundIndex = hash(keyName);

            if (_foundIndex <= _hashSlots) 
            {
                for (OrderGroupHashEntry *e = _buckets[_foundIndex]; e != NULL ; e = e._next)  
                {
                    if (e._key == keyName) 
                    {
                        _foundEntry = e;
                        found=true;
                        break;
                    }
                   
                    _foundPrev = e;
                }
            }
   
            return found;
        }

        uint getSlots() 
        {
            return _hashSlots;
        }
   
        bool rehash(uint newSize) 
        {
            bool ret = false;
            OrderGroupHashEntry* oldTable[];
   
            uint oldSize = _hashSlots;
   
            if (newSize <= getSlots()) 
            {
                ret = false;
            } 
            else if (ArrayResize(_buckets,newSize) != newSize) 
            {
                ret = false;
            } 
            else if (ArrayResize(oldTable,oldSize) != oldSize) 
            {
                ret = false; 
            } 
            else 
            {
                uint i = 0;
                for(i = 0 ; i < oldSize ; i++ ) oldTable[i] = _buckets[i];
                for(i = 0 ; i<newSize ; i++ ) _buckets[i] = NULL;
   
                _hashSlots = newSize;
                _resizeThreshold = (int)_hashSlots / 4 * 3; 
   
                for (uint oldHashCode = 0 ; oldHashCode<oldSize ; oldHashCode++) 
                {
                    OrderGroupHashEntry *next = NULL;
   
                    for (OrderGroupHashEntry *e = oldTable[oldHashCode] ; e != NULL ; e = next)  
                    {
                        next = e._next;
   
                        uint newHashCode = hash(e._key);
   
                        e._next = _buckets[newHashCode];
                        _buckets[newHashCode] = e;
                    }
   
                    oldTable[oldHashCode] = NULL;
                }
                ret = true;
            }
            return ret;
        }
       
    public:
        OrderGroupHashMap() 
        {
            init(13, false);
        }
   
        OrderGroupHashMap(bool adoptValues) 
        {
            init(13, adoptValues);
        }
   
        OrderGroupHashMap(int size) 
        {
            init(size, false);
        }
   
        OrderGroupHashMap(int size, bool adoptValues) 
        {
            init(size, adoptValues);
        }
   
        ~OrderGroupHashMap() 
        {
            for(uint i = 0 ; i< _hashSlots ; i++) 
            {
                OrderGroupHashEntry *nextEntry = NULL;
                for (OrderGroupHashEntry *entry = _buckets[i] ; entry!= NULL ; entry = nextEntry) 
                {
                    nextEntry = entry._next;
   
                    if (_adoptValues && entry._val != NULL && CheckPointer(entry._val) == POINTER_DYNAMIC) 
                    {
                        delete entry._val;
                    }
                    delete entry;
                }
                _buckets[i] = NULL;
            }
        }
   
        bool ContainsKey(string keyName) 
        {
            return find(keyName);
        }
   
        OrderGroupData* Get(string keyName) 
        {
            OrderGroupData *obj = NULL;
   
            if (find(keyName)) 
            {
                obj = _foundEntry._val;
            } 

            return obj;
        }

        void GetAllData(OrderGroupData* &data[])
        {
            for(uint i = 0 ; i < _hashSlots ; i++) 
            {
                OrderGroupHashEntry *nextEntry = NULL;
                for (OrderGroupHashEntry *entry = _buckets[i]; entry != NULL ; entry = nextEntry) 
                {
                    if (entry._val != NULL)
                    {
                        int size = ArraySize(data);
                        ArrayResize(data, size + 1);
                
                        data[size] = entry._val;
                        nextEntry = entry._next;
                    }
                }
            }
        }


        OrderGroupData* Put(string keyName, OrderGroupData *obj) 
        {
            OrderGroupData *ret = NULL;
            
            if (find(keyName)) 
            {
                ret = _foundEntry._val;
   
                if (_adoptValues && _foundEntry._val != NULL && CheckPointer(_foundEntry._val) == POINTER_DYNAMIC ) 
                {
                    delete _foundEntry._val;
                }
   
                _foundEntry._val = obj;
   
            } 
            else 
            {
                OrderGroupHashEntry* e = new OrderGroupHashEntry(keyName,obj);
                OrderGroupHashEntry* first = _buckets[_foundIndex];
                e._next = first;
                _buckets[_foundIndex] = e;
                _hashEntryCount++;
   
                if (_hashEntryCount > _resizeThreshold) 
                {
                    rehash(_hashSlots/2*3); 
                }
            }
            return ret;
        }
   
        bool Delete(string keyName) 
        {
            bool found = false;
   
            if (find(keyName)) 
            {
                OrderGroupHashEntry *next = _foundEntry._next;
                if (_foundPrev != NULL) 
                {
                    _foundPrev._next = next;
                } 
                else 
                {
                    _buckets[_foundIndex] = next;
                }
   
                if (_adoptValues && _foundEntry._val != NULL&& CheckPointer(_foundEntry._val) == POINTER_DYNAMIC) 
                {
                    delete _foundEntry._val;
                }
               
                delete _foundEntry;
                _hashEntryCount--;
                found=true;
            }
            return found;
        }

        int DeleteKeys(const string& keys[])
        {
           int count = 0;
           
           // delete key if found
           for (int i=0; i<ArraySize(keys); i++)
           {
              if (Delete(keys[i]))
                 count++;
           }
           
           return count;
        }
        
        int DeleteKeysExcept(const string& keys[])
        {
           int index = 0, count = 0;
           
           string hashedKeys[];
           ArrayResize(hashedKeys, _hashEntryCount);
           
           for(uint i=0 ; i<_hashSlots ; i++) 
           {
              OrderGroupHashEntry *nextEntry = NULL;
              for (OrderGroupHashEntry *entry = _buckets[i] ; entry!= NULL ; entry = nextEntry) 
              {
                 nextEntry = entry._next;
            
                 if (entry._key != NULL) 
                 {
                    hashedKeys[index] = entry._key;
                    index++;
                 }
              }
           }
            
           // delete other keys if found
           for (int i=0; i<ArraySize(hashedKeys); i++)
           {
              bool keep = false;
              for (int j=0; j<ArraySize(keys); j++)
              {
                 if (hashedKeys[i] == keys[j])
                 {
                    keep = true;
                    break;
                 }
              }
              
              if (!keep)
              {
                 if (Delete(hashedKeys[i]))
                    count++;
              }
           }
           
           return count;
        }
};

//
//  Wallet
//
class Wallet
{
   private:
      // Orders currently open
      OrderCollection* _openOrders;
      // Orders currently open by Symbol + Type
      OrderGroupHashMap* _openOrdersSymbolType;
      // Orders currently open by Symbol
      OrderGroupHashMap* _openOrdersSymbol;
      // Pending open order
      OrderCollection* _pendingOpenOrders;
      // Pending close order
      OrderCollection* _pendingCloseOrders;
      // Most recent closed orders
      Order* _mostRecentOpenedOrClosedOrder;
   
      OrderRepository* _orderRepository;   
                  
      void AddOrderToOpenOrderCollections(Order* order)
      {
         Order* newOpenOrder = new Order(order);
         _openOrders.Add(newOpenOrder);
         
         if (IsSymbolOrderTypeOrderGroupActivated())
         {
            string key = GetOrderGroupSymbolOrderTypeKey(order);
            OrderGroupData *orderGroupData = _openOrdersSymbolType.Get(key);
            if (orderGroupData == NULL)
            {
               orderGroupData = new OrderGroupData();
            }
             
            orderGroupData.OrderGroup.Add(newOpenOrder);
             
            _openOrdersSymbolType.Put(key, orderGroupData);
         }
         if (IsSymbolOrderGroupActivated())
         {
            string key = GetOrderGroupSymbolKey(order);
            OrderGroupData *orderGroupData = _openOrdersSymbol.Get(key);
            if (orderGroupData == NULL)
            {
               orderGroupData = new OrderGroupData();
            }
             
            orderGroupData.OrderGroup.Add(newOpenOrder);
             
            _openOrdersSymbol.Put(key, orderGroupData);
         }
      }
      
      bool RemoveOrderFromOpenOrderCollections(Order* order)
      {
         int key = GetOpenOrders().GetKeyByTicket(order.Ticket);
         if (key != -1)
         {        
            GetOpenOrders().Remove(key);
   
            // remove orders from buckets
            if (_openOrdersSymbolType != NULL)
            {
               string symbolOrderTypeKey = GetOrderGroupSymbolOrderTypeKey(order);
               OrderGroupData symbolOrderTypeGroupData = _openOrdersSymbolType.Get(symbolOrderTypeKey);
               int symbolOrderTypeIndex = symbolOrderTypeGroupData.OrderGroup.GetKeyByTicket(order.Ticket);
               symbolOrderTypeGroupData.OrderGroup.Remove(symbolOrderTypeIndex);
            }
            else if (_openOrdersSymbol != NULL)
            {
               string symbolKey = GetOrderGroupSymbolKey(order);
               OrderGroupData symbolGroupData = _openOrdersSymbol.Get(symbolKey);
               int symbolIndex = symbolGroupData.OrderGroup.GetKeyByTicket(order.Ticket);
               symbolGroupData.OrderGroup.Remove(symbolIndex);
            }
         }
         
         return key != -1;
      }
      
      string GetOrderGroupSymbolOrderTypeKey(Order* order)
      {
         return order.SymbolCode + IntegerToString(order.Type);
      }
      
      string GetOrderGroupSymbolKey(Order* order)
      {
         return order.SymbolCode;
      }
      
      bool IsSymbolOrderTypeOrderGroupActivated()
      {
         return _openOrdersSymbolType != NULL;
      }
      
      bool IsSymbolOrderGroupActivated()
      {
         return _openOrdersSymbol != NULL;
      }

   public:            
      void Wallet()
      {
         _pendingOpenOrders = new OrderCollection();
         _openOrdersSymbolType = NULL;
         _openOrdersSymbol = NULL;
         _pendingCloseOrders = new OrderCollection();
         _orderRepository = new OrderRepository();

         _openOrders = new OrderCollection();
         _mostRecentOpenedOrClosedOrder = NULL;
      }
      
      void ~Wallet()
      {
         delete(_pendingOpenOrders);
         delete(_pendingCloseOrders);
         delete(_orderRepository);

         if (_openOrders != NULL)
            delete(_openOrders);

         if (_mostRecentOpenedOrClosedOrder != NULL)            
            delete(_mostRecentOpenedOrClosedOrder);

         if (_openOrdersSymbolType != NULL)
            delete(_openOrdersSymbolType);
            
         if (_openOrdersSymbol != NULL)
            delete (_openOrdersSymbol);   
      }

      void ActivateOrderGroups(ORDER_GROUP_TYPE &groupTypes[])
      {
         for (int i = 0; i < ArrayRange(groupTypes,0); i++)
         {
            if (groupTypes[i] == SymbolOrderType && _openOrdersSymbolType == NULL)
            {
               _openOrdersSymbolType = new OrderGroupHashMap();
            }
            else if (groupTypes[i] == SymbolCode && _openOrdersSymbol == NULL)
            {
               _openOrdersSymbol = new OrderGroupHashMap();
            }
         }
      }
      
      OrderCollection* GetOpenOrders()
      {
         if (_openOrders == NULL)
            LoadOrdersFromBroker();
            
         return _openOrders;
      }
      
      void GetOpenOrdersSymbolOrderType(OrderGroupData* &data[])
      {
         _openOrdersSymbolType.GetAllData(data);
      }
      
      void GetOpenOrdersSymbol(OrderGroupData* &data[])
      {
         _openOrdersSymbol.GetAllData(data);
      }

      OrderCollection* GetPendingOpenOrders()
      {
         return _pendingOpenOrders;
      }
      
      OrderCollection* GetPendingCloseOrders()
      {
         return _pendingCloseOrders;
      }

	  void ResetPendingOrders()
      {
         delete(_pendingOpenOrders);
         delete(_pendingCloseOrders);

         _pendingOpenOrders = new OrderCollection();
         _pendingCloseOrders = new OrderCollection();
         
         Print("Wallet has " + IntegerToString(_pendingOpenOrders.Count()) + " pending open orders now.");
         Print("Wallet has " + IntegerToString(_pendingCloseOrders.Count()) + " pending close orders now.");
      }

      void ResetOpenOrders()
      {
         if (_openOrders != NULL)
         {
            delete(_openOrders);
            _openOrders = new OrderCollection();
         }
         
         if (_openOrdersSymbol != NULL)
         {
            delete(_openOrdersSymbol);
            _openOrdersSymbol = new OrderGroupHashMap();
         }
         
         if (_openOrdersSymbolType != NULL)
         {
            delete(_openOrdersSymbolType);
            _openOrdersSymbolType = new OrderGroupHashMap();
         }
      }
      
      Order* GetMostRecentOpenedOrClosedOrder()
      {
         return _mostRecentOpenedOrClosedOrder;
      }

      void SetMostRecentOpenedOrClosedOrder(Order* order)
      {
         if (_mostRecentOpenedOrClosedOrder == NULL)
         {
            _mostRecentOpenedOrClosedOrder = new Order(order);
         }
         else if (_mostRecentOpenedOrClosedOrder.CloseTime < order.OpenTime
            || _mostRecentOpenedOrClosedOrder.CloseTime < order.CloseTime
            || (_mostRecentOpenedOrClosedOrder.OpenTime < order.OpenTime && _mostRecentOpenedOrClosedOrder.CloseTime == 0))
         {
            delete(_mostRecentOpenedOrClosedOrder);
            _mostRecentOpenedOrClosedOrder = new Order(order);
         }
      }
   
      void LoadOrdersFromBroker()
      {
          OrderCollection* brokerOrders = OrderRepository::GetOpenOrders(MagicNumber);
          for(int i = 0; i < brokerOrders.Count(); i++)
          {
              Order* openOrder = brokerOrders.Get(i);
              AddOrderToOpenOrderCollections(openOrder);
              
              // Check if order is latest opened or closed order
              SetMostRecentOpenedOrClosedOrder(openOrder);
          }

          // Check if manual closed order is maybe the latest opened or closed order
          Order* lastClosedOrder = OrderRepository::GetLastClosedOrder();
          if (lastClosedOrder != NULL)
          {
            SetMostRecentOpenedOrClosedOrder(lastClosedOrder);
            delete(lastClosedOrder);
          }

          // refactor this later orderCount = _openOrders.Count() didn't work.
          int orderCount = 0;
          if (_openOrders.Count() > 0)
          {
              orderCount = _openOrders.Count();
          }

          delete(brokerOrders);

          Print("Wallet has " + IntegerToString(orderCount) + " orders now.");
      }
      
      bool MovePendingOpenToOpenOrders(Order* justOpenedOrder)
      {
         int key = _pendingOpenOrders.GetKeyByTicket(justOpenedOrder.Ticket);
         if (key != -1)
         {
            delete(_mostRecentOpenedOrClosedOrder);
            _mostRecentOpenedOrClosedOrder = new Order(justOpenedOrder);

            AddOrderToOpenOrderCollections(justOpenedOrder);
            delete(justOpenedOrder);

            _pendingOpenOrders.Remove(key);
            
            return true;
         }

         Alert("Couldn't move pending open order to opened orders for ticketid: " + IntegerToString(justOpenedOrder.Ticket));
         return false;
      }
      
      bool MoveOpenOrderToPendingCloseOrders(Order* orderToClose)
      {
         if (RemoveOrderFromOpenOrderCollections(orderToClose))
         {
            _pendingCloseOrders.Add(new Order(orderToClose));
            
            if (CheckPointer(orderToClose)!=POINTER_INVALID
               && CheckPointer(orderToClose) == POINTER_DYNAMIC)
               delete(orderToClose);
            
            return true;
         }

         Alert("Couldn't move open order to pendingclose orders for ticketid: " + IntegerToString(orderToClose.Ticket));
         return false;
      }
      
      bool MovePendingCloseToClosedOrders(Order* justClosedOrder)
      {
         int key = _pendingCloseOrders.GetKeyByTicket(justClosedOrder.Ticket);
         if (key != -1)
         {
            delete(_mostRecentOpenedOrClosedOrder);
            _mostRecentOpenedOrClosedOrder = new Order(justClosedOrder);
            
            _pendingCloseOrders.Remove(key);
            delete(justClosedOrder);
            
            return true;
         }
         
         Alert("Couldn't move open order to removed order for ticketid: " + IntegerToString(justClosedOrder.Ticket));
         return false;
      }
};


//
//  TradeAction
//
enum TradeAction
{
	UnknownAction = 0,
	OpenBuyAction = 1,
	OpenSellAction = 2,
	CloseBuyAction = 3,
	CloseSellAction = 4
};

//
//  AdvisorStrategyExpression interface
//
interface IAdvisorStrategyExpression
{
   bool Evaluate();
};

//
//  TradeSignalCollection
//
class TradeSignalCollection
{
    private:
        IAdvisorStrategyExpression* _tradeSignals[];
        int _pointer;
        int _size;

    public:
        void TradeSignalCollection()
        {
            _pointer = -1;
            _size = 0;
        }

        void ~TradeSignalCollection()
        {
            for (int i = 0; i < ArraySize(_tradeSignals); i++)
            {
                delete(_tradeSignals[i]);
            }
        }

        void Add(IAdvisorStrategyExpression* item)
        {
            _size = _size + 1;
            ArrayResize(_tradeSignals, _size, 8);

            _tradeSignals[(_size - 1)] = item;
        }

        IAdvisorStrategyExpression* Remove(int index)
        {
            IAdvisorStrategyExpression* removed = NULL;

            if (index >= 0 && index < _size)
            {
               removed = _tradeSignals[index];
               
               for (int i = index; i < (_size - 1); i++)
               {
                   _tradeSignals[i] = _tradeSignals[i + 1];
               }
   
               ArrayResize(_tradeSignals, ArraySize(_tradeSignals) - 1, 8);
               _size = _size - 1;
            }
            
            return removed;
        }

        IAdvisorStrategyExpression* Get(int index)
        {
            if (index >= 0 && index < _size)
            {
                return _tradeSignals[index];
            }

            return NULL;
        }

        int Count()
        {
            return _size;
        }

        void Rewind()
        {
            _pointer = -1;
        }

        IAdvisorStrategyExpression* Next()
        {
            _pointer++;
            if (_pointer == _size)
            {
                Rewind();
                return NULL;
            }

            return Current();
        }

        IAdvisorStrategyExpression* Prev()
        {
            _pointer--;
            if (_pointer == -1)
            {
                return NULL;
            }

            return Current();
        }

        bool HasNext()
        {
            return (_pointer < (_size - 1));
        }

        IAdvisorStrategyExpression* Current()
        {
            return _tradeSignals[_pointer];
        }

        int Key()
        {
            return _pointer;
        }
        
};

//
//  AdvisorStrategy
//
class AdvisorStrategy
{
	private:
		TradeSignalCollection* _openBuySignals;
		TradeSignalCollection* _openSellSignals;
		TradeSignalCollection* _closeBuySignals;
		TradeSignalCollection* _closeSellSignals;

	public:
   
		void AdvisorStrategy()
		{
			_openBuySignals = new TradeSignalCollection();
			_openSellSignals = new TradeSignalCollection();
			_closeBuySignals = new TradeSignalCollection();
			_closeSellSignals = new TradeSignalCollection();
		}
   
		void ~AdvisorStrategy()
		{
			delete(_openBuySignals);
			delete(_openSellSignals);
			delete(_closeBuySignals);
			delete(_closeSellSignals);
		}
   
		bool GetAdvice(TradeAction tradeAction, int level)
		{
			if (tradeAction == OpenBuyAction)
			{
				return EvaluateASLevel(_openBuySignals, level);
			}
			else if (tradeAction == OpenSellAction)
			{
				return EvaluateASLevel(_openSellSignals, level);
			}
			else if (tradeAction == CloseBuyAction)
			{
				return EvaluateASLevel(_closeBuySignals, level);
			}
			else if (tradeAction == CloseSellAction)
			{
				return EvaluateASLevel(_closeSellSignals, level);
			}
			else
			{
				Alert("Unsupported OrderType in Advisor Strategy");
			}

			return false;
		}
   
		bool EvaluateASLevel(TradeSignalCollection* signals, int level)
		{
			if (level > 0
				&& level <= signals.Count())
			{
				return signals.Get(level-1).Evaluate();
			}
	
			return false;
		}
   
		void RegisterOpenBuy(IAdvisorStrategyExpression* openBuySignal, int level)
		{
			if (level <= _openBuySignals.Count())
			{
				Alert("Register Open Buy failed: level already set.");
				return;
			}
   
			_openBuySignals.Add(openBuySignal);
		}
   
		void RegisterOpenSell(IAdvisorStrategyExpression* openSellSignal, int level)
		{
			if (level <= _openSellSignals.Count())
			{
				Alert("Register Open Sell failed: level already set.");
				return;
			}
   
			_openSellSignals.Add(openSellSignal);
		}
   
		void RegisterCloseBuy(IAdvisorStrategyExpression* closeBuySignal, int level)
		{
			if (level <= _closeBuySignals.Count())
			{
				Alert("Register Close Buy failed: level already set.");
				return;
			}
   
			_closeBuySignals.Add(closeBuySignal);
		}
   
		void RegisterCloseSell(IAdvisorStrategyExpression* closeSellSignal, int level)
		{
			if (level <= _closeSellSignals.Count())
			{
				Alert("Register Close Buy failed: level already set.");
				return;
			}
   
			_closeSellSignals.Add(closeSellSignal);
		}

		int GetNumberOfExpressions(TradeAction tradeAction)
		{
		   if (tradeAction == OpenBuyAction)
			{
				return _openBuySignals.Count();
			}
			else if (tradeAction == OpenSellAction)
			{
				return _openSellSignals.Count();
			}
			else if (tradeAction == CloseBuyAction)
			{
				return _closeBuySignals.Count();
			}
			else if (tradeAction == CloseSellAction)
			{
				return _closeSellSignals.Count();
			}
			return 0;
		}
};

//
//  AdvisorStrategySignals
//
// input group "OpenBuy_Constants"
input double OpenBuy_Const_0 = 1;

class ASOpenBuyLevel1 : public IAdvisorStrategyExpression
{
   public:
   
   void ASOpenBuyLevel1()
   {
   }
   
   bool Evaluate()
   {
      if ((Ask_LibFunc() > (iClose(Symbol(),PERIOD_M1,1) + OpenBuy_Const_0)
)
)
      {
         return true;
      }

      return false;
   }
};

// input group "OpenSell_Constants"
input double OpenSell_Const_0 = 1;

class ASOpenSellLevel1 : public IAdvisorStrategyExpression
{
   public:
   
   void ASOpenSellLevel1()
   {
   }
   
   bool Evaluate()
   {
      if ((Bid_LibFunc() < (iClose(Symbol(),PERIOD_M1,1) - OpenSell_Const_0)
)
)
      {
         return true;
      }

      return false;
   }
};

//
//  MoneyManager Interface
//
interface IMoneyManager
{
   double GetLotSize();
   int GetNextLevel(Wallet* wallet);
};

double NormalizeLots(double lots, string pair="")
{
    if (pair == "") pair = Symbol();
    double  lotStep = MarketInfo_LibFunc(pair, MODE_LOTSTEP),
            minLot  = MarketInfo_LibFunc(pair, MODE_MINLOT);
    lots            = MathRound(lots/lotStep) * lotStep;
    if (lots < minLot) lots = minLot;
    return(lots);
}

//
//  MoneyManager Class
//
input double LotSizeOverride = 0;
double LotSize = 1;

class MoneyManager : public IMoneyManager
{
   public: 
      void MoneyManager()
      {
        if (LotSizeOverride != 0)
         {
            LotSize = LotSizeOverride;
         }
      }
      
      double GetLotSize()
      {
         // = [lotsize]
         return NormalizeLots(LotSize);
      }
      
      int GetNextLevel(Wallet* wallet)
      {
         return wallet.GetOpenOrders().Count() + 1;
      }   
};

//
//  TradingModuleModuleDemand
//
enum TradingModuleDemand
{
	NoneDemand = 0,
	NoBuyDemand = 1,
	NoSellDemand = 2,
	NoOpenDemand = 4,
	OpenBuySellDemand = 8,
	OpenBuyDemand = 16,
	OpenSellDemand = 32,
	CloseBuyDemand = 64,
	CloseSellDemand = 128,
	CloseBuySellDemand = 256
};

//
//  TradingModuleExpression Interface
//
interface ITradingModuleExpression
{
   bool Evaluate();
};

//
//  TradeStrategyModule Interface
//
interface ITradeStrategyModule
{
   TradingModuleDemand Evaluate(Wallet* wallet, TradingModuleDemand demand, int level = 1);
   void RegisterTradeSignal(ITradingModuleExpression* tradeSignal);
};

//
//  TradeStrategyOpenModule Interface
//
interface ITradeStrategyOpenModule : public ITradeStrategyModule
{
   TradingModuleDemand EvaluateSignals(Wallet* wallet, TradingModuleDemand demand, int level = 1);	
};

//
//  Close TradeStrategy module Interface
//
interface ITradeStrategyCloseModule : public ITradeStrategyModule
{
   ORDER_GROUP_TYPE GetOrderGroupingType();
};

//
//  TradeStrategy
//
class TradeStrategy
{
    public:
      ITradeStrategyCloseModule* CloseModules[];
    private:

      ITradeStrategyModule* _preventOpenModules[];
      ITradeStrategyOpenModule* _openModule;
      
      TradingModuleDemand EvaluatePreventOpenModules(Wallet* wallet, TradingModuleDemand preventOpenDemand, int evaluationLevel = 1)
      {
         // Check PreventOpen demands
         TradingModuleDemand preventOpenDemands[];
         ArrayResize(preventOpenDemands, ArraySize(_preventOpenModules), 8);

         for (int i = 0; i < ArraySize(_preventOpenModules); i++) 
         {
            preventOpenDemands[i] = _preventOpenModules[i].Evaluate(wallet, NoneDemand, evaluationLevel);
         }
         
         // Combine the advices into 1 advice (None, NoBuy, NoSell or NoOpen)
         return PreventOpenModuleBase::GetCombinedPreventOpenDemand(preventOpenDemands);
      }
      
      TradingModuleDemand EvaluateCloseModules(Wallet* wallet, TradingModuleDemand closeDemand, int evaluationLevel = 1)
      {
         // Check Close demands
         TradingModuleDemand closeDemands[];
         ArrayResize(closeDemands, ArraySize(CloseModules), 8);

         for (int i = 0; i < ArraySize(CloseModules); i++) 
         {
            closeDemands[i] = CloseModules[i].Evaluate(wallet, NoneDemand, evaluationLevel);
         }

         // Combine the advices into 1 advice (None, NoBuy, NoSell or NoOpen)
         return CloseModuleBase::GetCombinedCloseDemand(closeDemands);
      }
      
      // This method puts orders in the pendingCloseOrders collection if the TP/ SL are hit
      void EvaluateCloseConditions(Wallet* wallet, TradingModuleDemand signalDemand)
      {
         OrderCollection* openOrders = wallet.GetOpenOrders();
         if (openOrders.Count() == 0)
         {
            return;
         }
         
         // First open order
         int orderTypeOfOpeningOrder = wallet.GetOpenOrders().Get(0).Type;
         
         double bid = Bid_LibFunc();
         double ask = Ask_LibFunc();

         for (int i = openOrders.Count()-1; i >= 0; i--)
         {
            Order* order = openOrders.Get(i);
            double stopLossHit = (order.StopLoss != 0 && 
               (  (order.Type == ORDER_TYPE_BUY && bid <= order.StopLoss) || 
                  (order.Type == ORDER_TYPE_SELL && ask >= order.StopLoss)));
            double takeProfitHit = (order.TakeProfit != 0 && 
               (  (order.Type == ORDER_TYPE_BUY && bid >= order.TakeProfit) || 
                  (order.Type == ORDER_TYPE_SELL && ask <= order.TakeProfit)));
			double closeSignal = 
               (order.Type == OP_BUY && signalDemand == CloseBuyDemand)
               || (order.Type == OP_SELL && signalDemand == CloseSellDemand)
               || signalDemand == CloseBuySellDemand;   
 

            if (stopLossHit || takeProfitHit || closeSignal)
            {   
               // We want to evaluate the preventOpen pretending we're evaluating level 1 (what would happen if all orders were closed, which are now open)
               int evaluateLevel = 1;             
               TradingModuleDemand finalPreventOpenAdvice = EvaluatePreventOpenModules(wallet, NoneDemand, evaluateLevel);
               
               // Evaluate Open module and inform module of NoOpen demands
               TradingModuleDemand openDemand = _openModule.EvaluateSignals(wallet, finalPreventOpenAdvice, evaluateLevel);
               
               if ((orderTypeOfOpeningOrder == ORDER_TYPE_BUY && openDemand == OpenBuyDemand)
                  || (orderTypeOfOpeningOrder == ORDER_TYPE_SELL && openDemand == OpenSellDemand)
                  || (openDemand == OpenBuySellDemand))
                  {
                      // block close, because the order will be opened straight away again anyway
                      return;
                  }
               
               // Move order to PendingCloseOrders
               wallet.MoveOpenOrderToPendingCloseOrders(order);
            }
         }
      }
      
   public:
      void TradeStrategy(ITradeStrategyOpenModule* openModule)
      {
         _openModule = openModule;
      }
      
      void ~TradeStrategy()
      {
         for (int i=ArraySize(_preventOpenModules)-1; i >= 0; i--)
         {
            delete(_preventOpenModules[i]);
         }
         
         delete(_openModule);
         
         for (int i=ArraySize(CloseModules)-1; i >= 0; i--)
         {
            delete(CloseModules[i]);
         }
      }
      
      void Evaluate(Wallet* wallet)
      {
         TradingModuleDemand finalPreventOpenAdvice = EvaluatePreventOpenModules(wallet, NoneDemand);
         
         // Evaluate Open module and inform module of NoOpen demands
         TradingModuleDemand signalDemand = _openModule.Evaluate(wallet, finalPreventOpenAdvice, 0);
         
         if (wallet.GetOpenOrders().Count() > 0)
         {
            // Close modules set the TP/ SL in memory, don't persist to broker (optionally) or their dealing desk will screw you over
            EvaluateCloseModules(wallet, NoneDemand);
            
            // TP and SL can be modified by multiple modules. Here we evaluate the order's TP/SL with the current quote
            EvaluateCloseConditions(wallet, signalDemand);
         }
      }
      
      void RegisterPreventOpenModule(ITradeStrategyModule* preventOpenModule)
      {
         int size = ArraySize(_preventOpenModules);
         ArrayResize(_preventOpenModules, size + 1, 8);
         _preventOpenModules[size] = preventOpenModule;
      }
      
      void RegisterCloseModule(ITradeStrategyCloseModule* closeModule)
      {
         int size = ArraySize(CloseModules);
         ArrayResize(CloseModules, size + 1, 8);
         CloseModules[size] = closeModule;
      }
};

//
//  OpenModule BaseClass
//
class OpenModuleBase : public ITradeStrategyOpenModule
{
   protected:
      AdvisorStrategy* _advisorStrategy;
      IMoneyManager* _moneyManager;

      Order* OpenOrder(ENUM_ORDER_TYPE orderType)
      {
         Order* order = new Order();
         order.Type = orderType;
         order.MagicNumber = MagicNumber;
         order.Lots = _moneyManager.GetLotSize();
         if (order.Type == ORDER_TYPE_BUY)
         {
            order.OpenPrice = Ask_LibFunc();
			order.StopLoss = -DBL_MAX;
            order.TakeProfit = DBL_MAX;
         }
         else if (order.Type == ORDER_TYPE_SELL)
         {
            order.OpenPrice = Bid_LibFunc();
			order.StopLoss = DBL_MAX;
            order.TakeProfit = -DBL_MAX;
         }
		 order.LowestProfitPips = DBL_MAX;
         order.HighestProfitPips = -DBL_MAX;
         order.SymbolCode = Symbol();

         return order;
      }
      
   public:
      
      void OpenModuleBase(AdvisorStrategy* advisorStrategy, MoneyManager* moneyManager)
      {
         _advisorStrategy = advisorStrategy;
         _moneyManager = moneyManager;
      }
      
      void GetTradeActions(Wallet* wallet, TradingModuleDemand preventOpenDemand, TradeAction& result[])
      {
         TradeAction tempresult[];
         
         if (wallet.GetOpenOrders().Count() > 0)
         {
            // First open order is buy? then only reevaluate the buy AS levels for adding buys
            Order* firstOrder = wallet.GetOpenOrders().Get(0);
            if (firstOrder.Type == ORDER_TYPE_BUY)
            {
               ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
               tempresult[0] = OpenBuyAction;

			   ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
               tempresult[1] = CloseBuyAction;
            }
            else if (firstOrder.Type == ORDER_TYPE_SELL)
            {
               ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
               tempresult[0] = OpenSellAction;

			   ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
               tempresult[1] = CloseSellAction;
            }
            else
            {
               Alert("Unsupported ordertype");
            }
         }    
         else
         {
            ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
            tempresult[0] = OpenBuyAction;
            
            ArrayResize(tempresult, ArraySize(tempresult) + 1, 8);
            tempresult[1] = OpenSellAction;
         }
         
         // filter prevent open demands
         for(int i = 0; i < ArraySize(tempresult); i++)
         {         
            if (preventOpenDemand == NoOpenDemand
                    || (preventOpenDemand == NoBuyDemand && tempresult[i] == OpenBuyAction)
                    || (preventOpenDemand == NoSellDemand && tempresult[i] == OpenSellAction))
                {
                    continue;
                }
              
            ArrayResize(result, ArraySize(result) + 1, 8);
            result[ArraySize(result)-1] = tempresult[i];     
         }
      }

      virtual void RegisterTradeSignal(ITradingModuleExpression* tradeSignal)
      {
	     // nothing to do here	 
      }
      
      static TradingModuleDemand GetCombinedOpenDemand(TradingModuleDemand &openDemands[])
      {
         TradingModuleDemand result = NoneDemand;
         
         for (int i = 0; i < ArraySize(openDemands); i++) 
         {
            if (result == OpenBuySellDemand)
               return OpenBuySellDemand;
            
            if (openDemands[i] == OpenBuySellDemand)
            {
               result = OpenBuySellDemand;
            }
            else if (result == NoneDemand && openDemands[i] == OpenBuyDemand)
            {
               result = OpenBuyDemand;
            }
            else if (result == NoneDemand && openDemands[i] == OpenSellDemand)
            {
               result = OpenSellDemand;
            }
            else if (result == OpenBuyDemand && openDemands[i] == OpenSellDemand)
            {
               result = OpenBuySellDemand;
            }
            else if (result == OpenSellDemand && openDemands[i] == OpenBuyDemand)
            {
               result = OpenBuySellDemand;
            }
         }
         return result;    
      }

	  static TradingModuleDemand GetCombinedCloseDemand(TradingModuleDemand &closeDemands[])
      {
         TradingModuleDemand result = NoneDemand;
         
         for (int i = 0; i < ArraySize(closeDemands); i++) 
         {
            if (result == CloseBuySellDemand)
               return CloseBuySellDemand;
            
            if (closeDemands[i] == CloseBuySellDemand)
            {
               result = CloseBuySellDemand;
            }
            else if (result == NoneDemand && closeDemands[i] == CloseBuyDemand)
            {
               result = CloseBuyDemand;
            }
            else if (result == NoneDemand && closeDemands[i] == CloseSellDemand)
            {
               result = CloseSellDemand;
            }
            else if (result == CloseBuyDemand && closeDemands[i] == CloseSellDemand)
            {
               result = CloseBuySellDemand;
            }
            else if (result == CloseSellDemand && closeDemands[i] == CloseBuyDemand)
            {
               result = CloseBuySellDemand;
            }
         }
         return result;  
      }

      int GetNumberOfOpenOrders(Wallet* wallet)		
      {		
         return wallet.GetOpenOrders().Count();		
      } 
};

//
//  Single-order OpenModule 1
//
class SingleOpenModule_1 : public OpenModuleBase
{
   public:
  
      void SingleOpenModule_1(AdvisorStrategy* advisorStrategy, MoneyManager* moneyManager)
         : OpenModuleBase(advisorStrategy, moneyManager)
      {
      }

      TradingModuleDemand Evaluate(Wallet* wallet, TradingModuleDemand preventOpenDemand, int level)
      {
         TradingModuleDemand signalsDemand = EvaluateSignals(wallet, preventOpenDemand, level);
         if (signalsDemand != NoneDemand)
         {
            EvaluateOpenConditions(wallet, signalsDemand);
         }
         return signalsDemand;
      }
      
      TradingModuleDemand EvaluateSignals(Wallet* wallet, TradingModuleDemand preventOpenDemand, int requestedEvaluationLevel)
      {
         TradingModuleDemand openDemands[];
         TradingModuleDemand closeDemands[];
         
         // Get adviced open ordertypes
         TradeAction tradeActionsToEvaluate[];
         GetTradeActions(wallet, preventOpenDemand, tradeActionsToEvaluate);
         
         int moneyManagementLevel;
         if (requestedEvaluationLevel == 0)
         {
            moneyManagementLevel = _moneyManager.GetNextLevel(wallet);
         }
         else
         {
            moneyManagementLevel = requestedEvaluationLevel;
         }
         
         for(int i = 0; i < ArraySize(tradeActionsToEvaluate); i++)
         {  
            int tradeActionEvaluationLevel;
            if (tradeActionsToEvaluate[i] == CloseBuyAction
                || tradeActionsToEvaluate[i] == CloseSellAction)
            {
                // Single order module will never evaluate level 2, however it should evaluate level 1 close signals
                tradeActionEvaluationLevel = moneyManagementLevel - 1;
            }
            else
            {
                tradeActionEvaluationLevel = moneyManagementLevel;
            }

            if (_advisorStrategy.GetAdvice(tradeActionsToEvaluate[i], tradeActionEvaluationLevel))
            {
               if (tradeActionsToEvaluate[i] == OpenBuyAction)
               {
                  int size = ArraySize(openDemands);
                  int newSize = size + 1;
                  ArrayResize(openDemands, newSize, 8);
                  openDemands[newSize-1] = OpenBuyDemand;
               }
               else if (tradeActionsToEvaluate[i] == OpenSellAction)
               {
                  int size = ArraySize(openDemands);
                  int newSize = size + 1;
                  ArrayResize(openDemands, newSize, 8);
                  openDemands[newSize-1] = OpenSellDemand;
               }
               else if (tradeActionsToEvaluate[i] == CloseBuyAction)
               {
                  int size = ArraySize(closeDemands);
                  int newSize = size + 1;
                  ArrayResize(closeDemands, newSize, 8);
                  closeDemands[newSize - 1] = CloseBuyDemand;
               }
               else if (tradeActionsToEvaluate[i] == CloseSellAction)
               {
                  int size = ArraySize(closeDemands);
                  int newSize = size + 1;
                  ArrayResize(closeDemands, newSize, 8);
                  closeDemands[newSize - 1] = CloseSellDemand;
               }
            }
         }

         TradingModuleDemand combinedCloseSignalDemand = OpenModuleBase::GetCombinedCloseDemand(closeDemands);
         if (combinedCloseSignalDemand != NoneDemand)
         {
            return combinedCloseSignalDemand;
         }
         
         TradingModuleDemand combinedOpenSignalDemand = OpenModuleBase::GetCombinedOpenDemand(openDemands);
         return combinedOpenSignalDemand;
     }      

     // This method puts orders in the pendingOpenOrders collection if the advisor says it should open orders
     void EvaluateOpenConditions(Wallet* wallet, TradingModuleDemand signalDemand)
     {
         // Open orders based on openDemand
         if (signalDemand == OpenBuyDemand)
         {
            wallet.GetPendingOpenOrders().Add(OpenOrder(ORDER_TYPE_BUY));
         }
         else if (signalDemand == OpenSellDemand)
         {
            wallet.GetPendingOpenOrders().Add(OpenOrder(ORDER_TYPE_SELL));
         }
         else if (signalDemand == OpenBuySellDemand)
         {
            wallet.GetPendingOpenOrders().Add(OpenOrder(ORDER_TYPE_BUY));
            wallet.GetPendingOpenOrders().Add(OpenOrder(ORDER_TYPE_SELL));
         }
      }
};

//
//  CloseModule BaseClass
//
class CloseModuleBase : public ITradeStrategyCloseModule
{
   protected:
   
      bool SetNewTakeProfit(Order* order, double possibleNewTakeProfit)
      {
         double newTakeProfit = order.TakeProfit == NULL ? possibleNewTakeProfit : order.Type == OP_BUY ? MathMin((double)order.TakeProfit, possibleNewTakeProfit) : MathMax(order.TakeProfit, possibleNewTakeProfit);
         if (order.TakeProfit == NULL || MathAbs(newTakeProfit - (double)order.TakeProfit) > 0)
         {
             order.TakeProfit = newTakeProfit;
             return true;
         }
         return false;
      }
      
      bool SetNewStopLoss(Order* order, double possibleNewStopLoss)
      {
         double newStopLoss = order.StopLoss == NULL ? possibleNewStopLoss : order.Type == OP_BUY ? MathMax((double)order.StopLoss, possibleNewStopLoss) : MathMin(order.StopLoss, possibleNewStopLoss);
         if (order.StopLoss == NULL || MathAbs(newStopLoss - order.StopLoss) > 0)
         {
            //Print("New stop loss set.");               
            order.StopLoss = newStopLoss;
            return true;
         }
         return false;
      }

      void SetOrderStopLossToClosePrice(Order* openOrder, string moduleComment = "")
      {
         double possibleNewStopLoss = GetClosePrice(openOrder.Type);
         if (SetNewStopLoss(openOrder, possibleNewStopLoss))
         {
            //Print("SL set: " + possibleNewStopLoss);
            if (moduleComment != "")
            {
               openOrder.Comment = moduleComment; //"Order closed by StopLossCloseModule";
            }
         }
      }
      
      void SetOrderTakeProfitToClosePrice(Order* openOrder, string moduleComment = "")
      {
         double possibleNewTakeProfit = CloseModuleBase::GetClosePrice(openOrder.Type);
         if (SetNewTakeProfit(openOrder, possibleNewTakeProfit))
         {
            if (moduleComment != "")
            {
               openOrder.Comment = moduleComment;
            }
         }
      }
      
      double CalculateOrderProfitSingleOrder(Order* order, ORDER_GROUP_TYPE groupType, ORDER_PROFIT_CALCULATION_TYPE calculationType)
      {
         if (calculationType == Pips)
         {
            return order.CalculateProfitPips();
         }
         else if (calculationType == Money)
         {
            return order.CalculateProfitCurrency();
         }
         else
         {
            Alert("Can't execute CalculateOrderProfit. Unknown calculationType: " + IntegerToString(calculationType) );
         }
         
         return 0;
      }
      
      double CalculateOrderCollectionProfit(OrderCollection &openOrders, ORDER_PROFIT_CALCULATION_TYPE calculationType)
      {
         double collectionProfit = 0;
         for(int i = 0; i < openOrders.Count(); i++)
         {
            Order* openOrder = openOrders.Get(i);
            if (calculationType == Pips)
            {
               collectionProfit += openOrder.CalculateProfitPips();
            }
            else if (calculationType == Money)
            {
               collectionProfit += openOrder.CalculateProfitCurrency();
            }
            else
            {
               Alert("Can't execute CalculateOrderCollectionProfit. Unknown calculationType: " + IntegerToString(calculationType) );
            }
         }
         
         return collectionProfit;
      }
      
      static double GetClosePrice(int orderType)
      {
         switch (orderType)
         {
             case ORDER_TYPE_SELL:
                 return Ask_LibFunc();
             case ORDER_TYPE_BUY:
                 return Bid_LibFunc();
             default:
                 return 0;
         }
      }
      
      public:
      virtual void RegisterTradeSignal(ITradingModuleExpression* tradeSignal)
      {
	     // nothing to do here	 
      }
      
      static TradingModuleDemand GetCombinedCloseDemand(TradingModuleDemand &closeDemands[])
      {
         TradingModuleDemand result = NoneDemand;
         
         for (int i = 0; i < ArraySize(closeDemands); i++) 
		 {
            if (result == CloseBuySellDemand)
               return CloseBuySellDemand;
            
            if (closeDemands[i] == CloseBuySellDemand)
            {
               result = CloseBuySellDemand;
            }
            else if (result == NoneDemand && closeDemands[i] == CloseBuyDemand)
            {
               result = CloseBuyDemand;
            }
            else if (result == NoneDemand && closeDemands[i] == CloseSellDemand)
            {
               result = CloseSellDemand;
            }
            else if (result == CloseBuyDemand && closeDemands[i] == CloseSellDemand)
            {
               result = CloseBuySellDemand;
            }
            else if (result == CloseSellDemand && closeDemands[i] == CloseBuyDemand)
            {
               result = CloseBuySellDemand;
            }
         }
         return result;  
      }    

      virtual ORDER_GROUP_TYPE GetOrderGroupingType() = NULL;   
};
//
//  PreventOpenModule BaseClass
//
class PreventOpenModuleBase : public ITradeStrategyModule
{
   public:
      virtual void RegisterTradeSignal(ITradingModuleExpression* tradeSignal)
      {
	     // nothing to do here	 
      }
      
      static TradingModuleDemand GetCombinedPreventOpenDemand(TradingModuleDemand &preventOpenAdvices[])
      {
         TradingModuleDemand result = NoneDemand;
         
         for (int i = 0; i < ArraySize(preventOpenAdvices); i++) 
         {
            if (result == NoOpenDemand)
               return NoOpenDemand;
            
            if (preventOpenAdvices[i] == NoOpenDemand)
            {
               result = NoOpenDemand;
            }
            else if (result == NoneDemand && preventOpenAdvices[i] == NoBuyDemand)
            {
               result = NoBuyDemand;
            }
            else if (result == NoneDemand && preventOpenAdvices[i] == NoSellDemand)
            {
               result = NoSellDemand;
            }
            else if (result == NoBuyDemand && preventOpenAdvices[i] == NoSellDemand)
            {
               result = NoOpenDemand;
            }
            else if (result == NoSellDemand && preventOpenAdvices[i] == NoBuyDemand)
            {
               result = NoOpenDemand;
            }
         }
         return result;    
      }    
};

//
//  TradingSession PreventOpenModule 1
//


bool IsInTimeSession(int startHourServerTime, int startMinuteServerTime, int stopHourServerTime, int stopMinuteServerTime, datetime currentServerTime)
{
   //--- session start time
   int startTime = 3600 * startHourServerTime + 60 * startMinuteServerTime;

   //--- session end time
   int stopTime = 3600 * stopHourServerTime + 60 * stopMinuteServerTime;
   
   //--- current time in seconds since the day start
   currentServerTime = currentServerTime % 86400;
   
   if (stopTime < startTime)
   {
      //--- going past midnight
      if (currentServerTime >= startTime || currentServerTime < stopTime)
      {
         return(true);
      }
   }
   else
   {
      //--- within one day
      if (currentServerTime >= startTime && currentServerTime < stopTime)
      {
         return(true);
      }
   }
   return(false);
}

input int StartOpeningHourServerTime1 = 13;
input int StartOpeningMinuteServerTime1 = 31;
input int StopOpeningHourServerTime1 = 13;
input int StopOpeningMinuteServerTime1 = 32;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class TradingSessionPreventOpenModule_1: public PreventOpenModuleBase
{
public:
   void TradingSessionPreventOpenModule_1()
   {
   }

   TradingModuleDemand Evaluate(Wallet* wallet, TradingModuleDemand demand, int level = 1)
   {
      TradingModuleDemand result = NoneDemand;
      TradingModuleDemand preventOpenAdvices[];

      datetime currentServerTime = TimeCurrent();
      bool isWithinTimeSession = IsInTimeSession(StartOpeningHourServerTime1, StartOpeningMinuteServerTime1, 
         StopOpeningHourServerTime1, StopOpeningMinuteServerTime1, currentServerTime);
      if (!isWithinTimeSession)
      {
         int arraySize = ArraySize(preventOpenAdvices);
         int newArraySize = arraySize + 1;
         ArrayResize(preventOpenAdvices, newArraySize, 8);

         preventOpenAdvices[newArraySize - 1] = NoOpenDemand;
      }
      
      result = PreventOpenModuleBase::GetCombinedPreventOpenDemand(preventOpenAdvices);
      return result;
     }
  };

//
//  Trader Interface
//
interface ITrader
{
   void HandleTick();
   void Init();
};

ITrader *_ea;

//
//  Expert Advisor Class
//
class EA : public ITrader
{
    private:
        TradeStrategy* _tradeStrategy;
        AdvisorStrategy* _advisorStrategy;
        IMoneyManager* _moneyManager;
        Wallet* _wallet;
                  
    public:
        void EA()
        {
            _wallet = new Wallet();
            _wallet.LoadOrdersFromBroker();
               
            // Advisor Strategy
            _advisorStrategy = new AdvisorStrategy();
            _advisorStrategy.RegisterOpenBuy(new ASOpenBuyLevel1(), 1);
            _advisorStrategy.RegisterOpenSell(new ASOpenSellLevel1(), 1);

            // MoneyManager
            _moneyManager = new MoneyManager();

            // Trader Strategy
            _tradeStrategy = new TradeStrategy(new SingleOpenModule_1(_advisorStrategy, _moneyManager));

            // Dynamic Modules
            _tradeStrategy.RegisterPreventOpenModule(new TradingSessionPreventOpenModule_1());

        }
           
        void ~EA()
        {
            delete(_tradeStrategy);
            delete(_moneyManager);
            delete(_advisorStrategy);
            delete(_wallet);
        }

        void Init()
        {
            SetOrderGrouping();
        }

        void HandleTick()
        {
            if (StopEA)
            {
                return;
            }

            // Only check on live trading
            if (MQLInfoInteger(MQL_TESTER) == 0)
            {
               // if number of open orders is incorrect, reset in memory pending orders and load open orders
               SyncOrders();
            }

            // Update orders with latest tick quote
            UpdateOrders();
              
            if (_wallet.GetPendingOpenOrders().Count() == 0 && _wallet.GetPendingCloseOrders().Count() == 0)
            {
                _tradeStrategy.Evaluate(_wallet);
            }
   
            ExecutePendingCloseOrders();

            ExecutePendingOpenOrders();
        }
           
        private:     

        void SetOrderGrouping()
        {
            int size = ArraySize(_tradeStrategy.CloseModules);
            ORDER_GROUP_TYPE groups[];
            ArrayResize(groups, size);
            
            for(int i = 0; i < ArraySize(_tradeStrategy.CloseModules); i++)
            {
               groups[i] = _tradeStrategy.CloseModules[i].GetOrderGroupingType();
            }
            
            _wallet.ActivateOrderGroups(groups);
        }

        void SyncOrders()
        {
            OrderCollection* currentOpenOrders = OrderRepository::GetOpenOrders(MagicNumber, NULL);
            if (currentOpenOrders.Count() != _wallet.GetOpenOrders().Count())
            {
                Print("Manual orderchanges detected" + " (found in MT: " + IntegerToString(currentOpenOrders.Count()) + " and in wallet: " + IntegerToString(_wallet.GetOpenOrders().Count()) + "), resetting EA, loading open orders.");
            
                // An order was manually opened or closed, we reset everything
                _wallet.ResetOpenOrders();
                _wallet.ResetPendingOrders();
                _wallet.LoadOrdersFromBroker();
            }

            delete(currentOpenOrders);
        }
         
        void UpdateOrders()
        {
            // Print("Nr of open orders for update: " + _wallet.GetOpenOrders().Count());
            
            _wallet.GetOpenOrders().Rewind();
            while(_wallet.GetOpenOrders().HasNext())
            {
                Order* order = _wallet.GetOpenOrders().Next();
                double pipsProfit = order.CalculateProfitPips();
                order.CurrentProfitPips = pipsProfit;
                  
                if (pipsProfit<order.LowestProfitPips)
                {
                    order.LowestProfitPips = pipsProfit;
                }
                else if (pipsProfit > order.HighestProfitPips)
                {
                    order.HighestProfitPips = pipsProfit;
                }
            }
        }
            
        void ExecutePendingCloseOrders()
        {
            OrderCollection* pendingCloseOrders = _wallet.GetPendingCloseOrders();
            if (pendingCloseOrders.Count() == 0)
            {
               return;
            }
            
            for (int i = pendingCloseOrders.Count()-1; i >= 0; i--)
            {
               Order* pendingCloseOrder = pendingCloseOrders.Get(i);
           
               bool success = OrderRepository::ClosePosition(pendingCloseOrder);
               if (success)
               {
                  Order* closedOrder = OrderRepository::GetLastClosedOrder();
                  pendingCloseOrder.CloseTime = closedOrder.CloseTime;
                  delete (closedOrder);

                  _wallet.MovePendingCloseToClosedOrders(pendingCloseOrder);
               }
               else
               {
                  Print("ClosePosition failed!");
               }
            }
        }

        void ExecutePendingOpenOrders()
        {
            // Open pending open orders
            if (_wallet.GetPendingOpenOrders().Count() != 0)
            {
                OrderCollection* pendingOpenOrders = _wallet.GetPendingOpenOrders();
                for (int i = pendingOpenOrders.Count() - 1; i >= 0; i--)
                {
                    if (!MQL5InfoInteger(MQL5_TRADE_ALLOWED))
                    {
                        double StartWaitingTime = GetTickCount();
                        Print("Trade context is busy! Waiting until it is free...");
                        while(true)
                        {
                            int MaxWaiting_sec = 10;
                            // if the expert was terminated by the user, stop operation
                            if(IsStopped()) 
                            { 
                                Print("The expert was stopped by the user!"); 
                                return; 
                            }
                            
                            // if it is waited longer than it is specified in the variable named 
                            // MaxWaiting_sec, stop operation, as well
                            if(GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000) 
                            {
                                Print("The standby limit (" + DoubleToStr(MaxWaiting_sec) + " sec) exceeded!");
                                return;
                            }
                            
                            // if the trade context has become free,
                            if (MQL5InfoInteger(MQL5_TRADE_ALLOWED))
                            {
                                Print("Trade context is free!");
                                break;
                            }
                            Sleep(100);
                        }
                    }

                    Order* order = pendingOpenOrders.Get(i);
                    bool success = OrderRepository::OpenOrder(order);
                    if (success)
                    {
                        // Move order to OpenOrders
                        _wallet.MovePendingOpenToOpenOrders(order);
                    }
                }
            }
        }
};

//+------------------------------------------------------------------------+
//|  Expert Initialization Function                                        |
//+------------------------------------------------------------------------+

int OnInit()
{
	OrderFillingType = GetFillingType();
	if ((int)OrderFillingType == -1)
	{
	    Print("Unsupported filling type " + IntegerToString((int)OrderFillingType));
	    return (INIT_FAILED);
	}
	
	SetPipPoint();
	if (PipPoint == 0)
	{
		Print("Couldn't find correct point for symbol.");
	
	    return (INIT_FAILED);
	}
	
	_ea = new EA();
	_ea.Init();
	
	
	return (INIT_SUCCEEDED);
	
}

//+------------------------------------------------------------------------+
//|  Expert Deinitialization Function                                      |
//+------------------------------------------------------------------------+

void OnDeinit(const int reason)
{
	delete(_ea);
}

//+------------------------------------------------------------------------+
//|  Expert Advisor Function                                               |
//+------------------------------------------------------------------------+

void OnTick()
{
	_ea.HandleTick();
}


